import scala.collection.immutable.{Map,HashMap}

/*val fruit_to_color: Map[String, String] = Map("banana"->"yellow", 
                                              "blueberry"->"blue" ,
                                              "cherry" ->"red" ,
                                              "lemon" ->"yellow" ,
                                              "kiwi" ->"green" )*/

def reverse[A,B](map: Map[A,B]): Map[B, List[A]] = {
        val result = new HashMap[B, List[A]]
        for ((k,v) <- map) result.put(v, 
            result get v match{ // Returns an Option[List[A]]
                case Some(l) => k :: l 
                case None => List(k) 
            })
        result
}

/*def reverse2[A,B](map: Map[A,B]): Map[B, List[A]] = 
    map.groupBy({case (a,b) =>b }).mapValues(_.keys.toList)
*/
val result = reverse2(fruit_to_color)
println(fruit_to_color)
println(result)
